﻿<?xml version="1.0"?>
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<!-- 
<purpose>html-view for static xml-files</purpose>
<params>
<param name=""></param>
</params>
<history>
	<change on="2010-11-12" type="created" by="vr">based on xml2htmltable</change>	
	
</history>
-->

<xsl:include href="cmd_commons.xsl"/> 

<xsl:param name="title" select="if (//div[1][@class='title']) then concat('CMDRSB: ', //div[1][@class='title']) else 'CMDRSB docs'" />

	
<!--<xsl:output method="html" encoding="UTF-8"/>-->

<xsl:template name="continue-root">
	<div class="info">
		<a href="{$docs_baseuri}" >home</a>
		<xsl:apply-templates  select="info/*[not(@class='title')]" />	
    </div>
</xsl:template>

<xsl:template match="div[@id='commands']">
	<xsl:copy>	
		<xsl:apply-templates select="p|div|span|h3" />						
		<dl>		
		<xsl:for-each select="dl/dt" >		
			<dt><span class="cmd {@id}"> </span><xsl:value-of select="." /></dt>
			<xsl:copy-of select="following-sibling::*[1][name()='dd']" />
		</xsl:for-each>
		</dl>		
	</xsl:copy>
</xsl:template>

<xsl:template match="*|@*">
	<xsl:copy>
		<xsl:apply-templates select="node()|@*" />
	</xsl:copy>	
</xsl:template>


</xsl:stylesheet>
  